#include <Application.h>
#include <StorageKit.h>

#include <stdio.h>  // Basic input/output.
#include <string.h> // Posix string includes.

#include <be/add-ons/tracker/TrackerAddon.h>

void process_refs(entry_ref unused_ref, BMessage *message, void *) {  // Unsed_ref points to present directory.
//   Since files passed to add-ons can exist in more than one directory I think this variable should be skipped.

// Objects needed.
  BFile  File_Object;  // BFile object.
  BPath  File_B_Path;  // Path to file (includes file name in full path).
  BEntry File_B_Entry; // BEntry converted from entry_ref.

  entry_ref file_entry_ref; // File Entry.
  off_t     File_Size;      // Length of file.
  uchar*    File_Buffer;    // Memory Buffer to store file to filter.
  status_t  File_Error;     // The error/return code
  size_t    Bytes_Read;     // Number of bytes read in from file.
  char      name[B_FILE_NAME_LENGTH];

  int    refs;          // Index into list of files passed to Addon
  int    ASC;           // Printable Ascii character,
  int    Index_Counter; // General Counter.

  for (refs=0; message->FindRef("refs", refs, &file_entry_ref) == B_NO_ERROR; refs++) { // Process file if no error finding next file ref.
      File_Error = File_B_Entry.SetTo(&file_entry_ref,false); // Convert a entry_ref to a BEntry.
      File_Error = File_B_Entry.GetPath(&File_B_Path);        // Get BPath from BEntry.

      File_Error = File_Object.SetTo(&file_entry_ref, B_READ_ONLY);  // Set BFile object to filter.  ReadOnly protects file from changes.
      File_Error = File_Object.GetSize(&File_Size);                  // Get size of file to filter.
      File_Buffer = new uchar[File_Size+255];                        // Create file buffer with extra buffering for overruns.
      Bytes_Read = File_Object.Read(File_Buffer, (size_t)File_Size); // Read file into buffer for filtering.
      File_Object.Unset();                                           // Close File.

      for (Index_Counter = 0; Index_Counter < File_Size; Index_Counter++) { // Process entire buffered file.
          ASC = (int)File_Buffer[Index_Counter] & 127; // Get a single character. Filter out high bit.
          if ((ASC > 31)|(ASC == 13)|(ASC == 10)) {    // Test if printable.
             File_Buffer[Index_Counter] = (char)ASC;   // Write printable filtered byte into buffer.
          } else {                                     // If not printable then,
             File_Buffer[Index_Counter] = 64; } }      // Write replacement byte into buffer. Can be any printable character.

      strcpy(name,File_B_Path.Path()); strcat(name,"-Filtered");// Rename file path/name from BEntry.
      File_Error = File_Object.SetTo(name, B_WRITE_ONLY|B_CREATE_FILE|B_ERASE_FILE); // Set BFile object to filter.
      File_Error = File_Object.Write((void *)File_Buffer, (size_t)File_Size);             // Write filtered file.
      File_Object.Unset(); delete []File_Buffer; } } // Close File.  Delete array.

int main()
{ new BApplication("application/x-trackeraddon.FileFilter_0.50"); delete be_app; }