//#include Filter.h
#include <Application.h>
#include <StorageKit.h>
#include <String.h>
#include <File.h>
#include <Path.h>
#include <stdlib.h>
#include <stdio.h>

  int      n;           // Counter
  off_t    File_Size;   // Length of file.
  uchar*   File_Buffer; // Memory Buffer to store file to filter.
  status_t err;         // The error/return code

class TFilter
{ public:
        TFilter(void);
       ~TFilter(void);
bool    Read_File(BString);
bool    Filter_Data(void);
bool    Write_File(BString); };

//#include "User_Input.cpp"
int main(int argc, char *argv[])
{ BString File_Name = "";
  BString Usage = "Usage:  ";
  
  printf("Freeware Version 0.50 File Filter program.\n");
  Usage.Append(argv[0]); Usage.Append(" VERSION | <FileName>");

  if (argc<2) {
     printf("Missing arguement. %s \n",Usage.String()); }

  if (argc==2) {
     if (strcmp("VERSION",argv[1])==0 | strcmp("version",argv[1])==0) {
        printf(" %s \n",Usage.String()); 
        printf(" VERSION 0.50\n");
        printf(" Written by Earl Colby Pottinger.\n");
        printf(" July 28, 2003.  Whitby, Ontario, Canada.\n");
     } else {
        File_Name = argv[1];
        printf("Filtering unprintable characters from %s \n",File_Name.String());
        TFilter *Filtering = new TFilter();
        Filtering->Read_File(File_Name);
        Filtering->Filter_Data(); Filtering->Write_File(File_Name); } }

  if (argc>2) {
     for (n=1; n<argc; n++) {
         File_Name = argv[n];
         printf("Filtering unprintable characters from %s \n",File_Name.String());
         TFilter *Filtering = new TFilter();
         Filtering->Read_File(File_Name);
         Filtering->Filter_Data();
         Filtering->Write_File(File_Name); } }

  return 0; }
  
// FileFilter 0.50 by Earl Colby Pottinger. 
// Partly based on code found in the Beos CDROM 
// Partly based on instructions found in "Programming the Be Operating System" By Dan Parks Sydow. 
// Additional help by Larry Baydak in debugging and coding/commenting style. 

TFilter::TFilter(void)
{ printf("Filter Setup Called.\n"); }

TFilter::~TFilter(void)
{ printf("Deconstructed Filter.\n"); }

bool TFilter::Read_File(BString File_Name)
{ BFile *File_Object; //size_t Bytes_Read;                 // Number of bytes read in from file.
  printf("Reading File %s.\n",File_Name.String());         // Prints on command stdio name of file being filtered.
  File_Object = new BFile(File_Name.String(),B_READ_ONLY); // Create BFile Object to filter file.  ReadOnly protects from changes.
  File_Object->GetSize(&File_Size);                        // Get size of file to filter
  File_Buffer = new uchar[File_Size+255];                  // Create file buffer with extra buffering.
  File_Object->Read(File_Buffer,File_Size);                // Read file into buffer for filtering.
  delete File_Object;                                      // Close file that was read in.
  return true; }

bool TFilter::Filter_Data(void)
{ int ASC; long Index_Counter; // Printable Ascii character, General Counter.
  printf("Filtering File Buffer.\n");
  for (Index_Counter = 0; Index_Counter < File_Size; Index_Counter++) { // Process entire buffered file.
      ASC=(int)File_Buffer[Index_Counter] & 127; // Get a single character. Filter out high bit.
      if ((ASC > 31)|(ASC == 13)|(ASC == 10)){
         File_Buffer[Index_Counter]=(char)ASC;   // Write printable filtered byte into buffer.
      } else {
         File_Buffer[Index_Counter]=64; } }      // Write replacement byte into buffer. Can be any printable character.
  return true; }

bool TFilter::Write_File(BString File_Name)
{ BFile *File_Object;
  File_Name.Append("-Filtered"); printf("Writing File %s.\n",File_Name.String());       // Create and print new file name.
  File_Object = new BFile(File_Name.String(), B_WRITE_ONLY|B_CREATE_FILE|B_ERASE_FILE); // Open file to write.
  File_Object->Write(File_Buffer,File_Size);                                            // Write out filtered file.
  delete File_Object;                                                                   // Close file that was written out.
  return true; }